#include "smgbalib.h"

int main() {

	// get ready for some displayin'
	Initialize();

	SeedRandom();
	
	// main loop - should never exit it
	while(1) {

		// display message
		EraseScreenNoPaletteNoFlip();
			
		WriteStringNarrow( 0, 0, "As we are waiting for user input, we" );
		WriteStringNarrow( 0, 8, "can keep polling for random numbers." );

		WriteStringNarrow( 0, 32,"We go through enough of them quickly" );
		WriteStringNarrow( 0, 40,"so that even small variations in how" );
		WriteStringNarrow( 0, 48,"long users take to press START creates" );
		WriteStringNarrow( 0, 56,"large variations in where we are in the" );
		WriteStringNarrow( 0, 64,"random number sequence" );
		
		WriteStringNarrow( 0, 80,"Press START to start the sequence and" );
		WriteStringNarrow( 0, 88,"list the first twenty random numbers." );

		WriteStringNarrow( 0, 104,"You can also reset the gameboy, and" );
		WriteStringNarrow( 0, 112,"try to get the same sequence. It" );
		WriteStringNarrow( 0, 120,"won't be easy." );

		WriteStringNarrow( 0, 136,"I suggest advancing the random number" );
		WriteStringNarrow( 0, 144,"sequence every time you wait for user" );
		WriteStringNarrow( 0, 152,"input, to get even more randomness." );


		// flip buffers, bringing the back one to the screen
		Flip();

		while(!IS_START_PRESSED) {
			// we don't care about the range
			// all we care is that we go through enough of them
			NextRandom( 1 ); 
		}

		//SeedRandom();

		u16 NUM_RANDOMS = 20;
		u16 randomNumbers[ NUM_RANDOMS ];
		u16 counter;
		for( counter = 0; counter < NUM_RANDOMS; counter++ ) {
			randomNumbers[counter] = NextRandom( 100 ) + 1; // random numbers between 1 and 100 inclusive
		}

		// all rendering happens in the back buffer
		EraseScreenNoPaletteNoFlip();

		char result[] = "           "; // allocate some space for the string :)

		for( counter = 0; counter < NUM_RANDOMS; counter++ ) {
			Itoa( result, randomNumbers[counter] );
			WriteStringWide( 0, counter*8, result );
		}

		WriteStringWide( 30, 71, "Press SELECT to return" );

		// flip buffers, bringing the back one to the screen
		Flip();

		while(!IS_SELECT_PRESSED) {
			NextRandom( 1 ); 
		}

	}
	
	return 0;
}
